# frozen_string_literal: true

require "json"

module BBSIA
  # Base error class
  class Error < StandardError; end

  # API error class
  class APIError < Error
    attr_reader :code, :message, :error

    def initialize(response)
      @code = response.code
      @message = response.message
      @error = JSON.parse(response.body) unless response.body.empty?
      super
    end

    def to_s
      "BBSIA::APIError => #{@code} #{@message} #{@error}"
    end
  end
end
